<?php
/*
 * User-friendly interface to SIEVE server-side mail filtering.
 * Plugin for Squirrelmail 1.2+
 *
 * Copyright (c) 2002 Alexandros Vellis <avel@users.sourceforge.net>
 *
 * Based on Dan Ellis' test scripts that came with sieve-php.lib
 * <danellis@rushmore.com> <URL:http://sieve-php.sourceforge.net>
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 */

/* addrule.php: Wizard-like form for adding new rules. */

require_once "addrule_html.inc";
require_once "buildrule.inc";
require_once "config.php";
require_once "support.inc";

chdir('..');
require_once('../functions/i18n.php');
//require_once('../functions/strings.php');
require_once('../config/config.php');
require_once('../src/load_prefs.php');
require_once('../functions/prefs.php');
require_once('../functions/imap.php');
require_once('../functions/plugin.php');
require_once('../functions/constants.php');
require_once('../functions/page_header.php');

/*	sess['key'] = "value";

key		values		comments
---		------		--------
start)
step		1, 2, 3, 4
type		1, 2, 3, 4	ruletype

1)
address$i	text (email)	$i = [0,2]          * explain below
addressrel$i	0 | and | or	rel. between address($i-1) <> address$i
TODO: add addresstype		if 0 then last email to check is at $i

2)
header$n	see print_2_2_headermatch()
matchtype$n	is | contains
headermatch$n	text
headerrel$n	0 | and | or

3)
sizerel		bigger | smaller
sizeamount	int
sizeunit	kb | mb

4)
n/a

action)
action		1 | 2 | 3 | 4 | 5 | 6
excuse		text		valid only for: action==3
redirectemail	text (email)	valid only for: action==4
folder				to check w/ Cyrus
				valid only for: action==5
vac_days
vac_addresses
vac_message			valid only for action=6
stop				valid for all


buttons:
-------
submit
finished
startover
cancel

_________
* example for multiple addresses

address0
addressrel1
address1
addressrel2
address2
addressrel3
address3

*/
require_once "config.php";
global $lang, $type, $startitems;

session_start();

if($cancel) {
	/* printheader($lang);
	print "DEBUG: User decided to cancel!";
	print "Ok, you lose. :-(";
	printnakedfooter($lang); */

	unset($sess);
	session_unregister('sess');
	unset($part);
	session_unregister('part');
	header("Location: table.php");
}

/* TO CHECK */
//if($sess['type'] == 4) {
//	$part = 3;
//}

if($startover || !isset($part) || (!$next && !$prev)) {
	$part = "1";
}

if($next) {	/* User moves on to next part */
	$part++;
} elseif($prev) {
	$part--;
}

if($part==2 && $next) {
	$sess['type'] = $HTTP_POST_VARS['type']; 
}

if($append) {
	$part=2;
	if (!$items) {
		$items = $startitems;
	} else {
		$items++;
	}
} elseif($less) {
	$part=2;
	if (!$items) {
		$items = $startitems;
	} else {
		$items--;
	}
} else {
	$items = $startitems;
}

if(($sess['type']==4) && ($part==2)) {
 	$part++;

}

if($createnewfolder && $action == 5 && $newfolder == "5b" && !$startover && !$cancel) {
/* User asked to create a new folder */
/* Variables:
	$folder_name = name of folder to create
	$subfolder   = name of folder under which to create $folder_name
*/
	/* Copy & paste magic (aka kludge) */

	require_once('../src/validate.php');
	require_once('../functions/display_messages.php');

	$imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);
	global $delimiter;

	$folder_name = trim($folder_name);

	if (strpos($folder_name, "\"") || strpos($folder_name, "\\") ||
	strpos($folder_name, "'") || strpos($folder_name, "$delimiter")) {
	/* Error handling...! */

		$part--;
		printheader($lang);

	    	plain_error_message("Illegal folder name.  Please select a different name.<BR><A HREF=\"../src/folders.php\">Click here to go back</A>.", $color);
		sqimap_logout($imapConnection);
		printfooter($lang);
		exit;
	}

	if (isset($contain_subs) && $contain_subs ) {
		$folder_name = "$folder_name$delimiter";
	}

	if ($folder_prefix && (substr($folder_prefix, -1) != $delimiter)) {
		$folder_prefix = $folder_prefix . $delimiter;
	}
	if ($folder_prefix && (substr($subfolder, 0, strlen($folder_prefix)) != $folder_prefix)){
		$subfolder_orig = $subfolder;
		$subfolder = $folder_prefix . $subfolder;
	} else {
		$subfolder_orig = $subfolder;
	}

	if (trim($subfolder_orig) == '') {
		$mailbox = $folder_prefix.$folder_name; 
	} else {
	$mailbox = $subfolder.$delimiter.$folder_name;
	}
	/*    if (strtolower($type) == 'noselect') {
	        $mailbox = $mailbox.$delimiter;
	    }
	*/

	sqimap_mailbox_create($imapConnection, $mailbox, '');

	/*    $read_ary = sqimap_run_command($imapConnection, "CREATE \"$mailbox\"",
	                                   false, $response, $message);
	*/
	 //   sqimap_subscribe ($imap_stream, $mailbox);

	/* $location = get_location();
	header ("Location: $location/folders.php?success=create"); */
	sqimap_logout($imapConnection);

	$folder = $subfolder.'.'.$folder_name;
	session_register('folder');
	// header("Location: addrule.php");

}

/* (A bit) kludgy: put global variables into sess[] */

if(!$finished) {

//global $HTTP_POST_VARS;

//print 'type is '.$sess['type'].', while part is '.$part.'.<br>Sess array is:';
//print "<pre>"; print_r($sess); print "</pre>"; 
//print "<br>enw oi post vars:";
//print "<pre>"; print_r($HTTP_POST_VARS); print "</pre><br>"; 

switch ($sess['type']) { 
	case "1":
		$vars = array( 'address', 'addressrel');
		foreach($vars as $myvar) {
			//print "DEBUG: Putting vars to our session array... sess[".$myvar."] = ".${$myvar}." <br />"; 
			$sess[$myvar]= ${$myvar};
		}
		break;
	case "2":
		/* Decide how much of the items to use for the rule, based on
		 * the first zero variable to be found. */
		//print "Edw eimaste. To mege8os twn header rules einai: ";
		//print sizeof($HTTP_POST_VARS['header']);
		
		if(!$HTTP_POST_VARS['headermatch'][0]) {
			//print "Error: You _have_ to define something!";
		}

		if(false) {
			print _("You have to define at least one header match text.");
		}
		
		for ($i=0; $i<sizeof($HTTP_POST_VARS['headermatch']) ; $i++) {
			if ($HTTP_POST_VARS['headermatch'][$i]) {
				//print "<p><em>START PROC</em>";
				$sess['header'][$i] = $HTTP_POST_VARS['header'][$i];
				$sess['matchtype'][$i] = $HTTP_POST_VARS['matchtype'][$i];
				$sess['headermatch'][$i] = $HTTP_POST_VARS['headermatch'][$i];
				if($i>0) {
					$sess['condition'] = $HTTP_POST_VARS['condition'];
				}
				//print "<b>Added $i series</b><br>";
				//print "<p><em>END PROC</em>";

			} elseif (!$HTTP_POST_VARS['headermatch'][$i]) {
				//print "end!<br>";
				break 1;
			} else {
				//print "Huh?"; 
			}
		}
		
		/* for ( $i=0; $i<3; $i++) {
			${'array'.$i} = array( "header$i", "matchtype$i", "headermatch$i", "headerrel$i");
		} */
		/* if(sizeof($vars) > 3) {
			$vars = array_merge($vars, $condition);
		}
		print_r($vars); */
		break;
	case "3":
		if($HTTP_POST_VARS['sizeamount']) {
			$vars = array( 'sizerel', 'sizeamount', 'sizeunit');
			foreach($vars as $myvar) {
				//print "DEBUG: Putting vars to our session array... sess[".$myvar."] = ".${$myvar}." <br />"; 
				$sess[$myvar]= ${$myvar};
			}
		}
		break;
	case "4":
		$dont = "1";
		break;
	default:
		$dont = "1";
		break;
}

if($action && ($new_folder != "5b" )){
	switch ($action) { 
		case "1": /* keep */
		case "2": /* discard */
			$vars = array( 'action');
			break;
		case "3": /* reject w/ excuse */
			$vars = array( 'action', 'excuse');
			break;
		case "4": /* redirect */
			$vars = array( 'action', 'redirectemail');
			break;
		case "5": /* fileinto */
			$vars = array( 'action', 'folder');
			break;
		case "6": /* vacation */
			$vars = array( 'action', 'vac_addresses', 'vac_days', 'vac_message');
			break;
		default:
			print "Invalid action value!";
			break;
	}
	if($stop) {
		$vars = array_merge($vars, array('stop'));
	}
	foreach($vars as $myvar) {
		//print "DEBUG: Putting vars to our session array... sess[".$myvar."] = ".${$myvar}." <br />"; 
		$sess[$myvar]= ${$myvar};
	}

}

/* if(!isset($dont) || isset($action) || $sess['type']!= "2") {
	foreach($vars as $myvar) {
		print "DEBUG: Putting vars to our session array... sess[".$myvar."] = ".${$myvar}." <br />"; 
		$sess[$myvar]= ${$myvar};
	}
} */

}

/* Register our variables back to the session */
session_register(sess);

if($finished || $apply) {
	/* $myscript = makesinglerule($sess,"rule");
	printheader($lang);
	print "Congratulations! Your script is as follows:<br /><pre>";
	print $myscript;
	print "</pre>";
	print "<p>The human-readable description of that is:<br />";
	$text = makesinglerule($sess,"text");
	print $text;
	printfooter($lang); */	
	/* print "<pre>"; print_r($sess); print "</pre>"; */
	$returnnewrule = urlencode(base64_encode(serialize($sess)));

/*	header ('Location: table.php?returnnewrule='.urlencode(base64_encode(serialize($sess)))); */

	session_register('returnnewrule'); 
	session_unregister('sess');
	session_unregister('part');
	header('Location: table.php');
	exit;
}

session_register(part);

/* END SESSION CODE */

/* No more HTTP headers below this line */
bindtextdomain ('avelsieve', '../locale');
textdomain('avelsieve');
	
printheader($lang);

/* BEGIN DEBUG CODE
print "<pre> DEBUG: Session "; print_r($HTTP_SESSION_VARS); print "</pre>";
print "<pre> DEBUG: HTTP Post "; print_r($HTTP_POST_VARS); print "</pre>";
END DEBUG CODE */

switch ($part) {

case "1":
	print_1_ruletype();
	break;

case "2":	
	/* $sess['type'] = $type; */
	switch ($sess['type']) { /* Nested switch: The second step depends on the type of the first step. */
	
		case "1":
			print_2_1_addressmatch($lang);
			break;

		case "2":
			print_2_2_headermatch($lang, $items);
			break;

		case "3":
			print_2_3_sizematch($lang);
			break;

		case "4": /* redundant */
			print 'Move on to the next step. Nothing to see here. :-)';
			break;

		default:
			print 'Oops, some error here. This shouldnt have happened.';
			print $sess['type'];
			printfooter($lang);
			exit;
			break;

		}
	break;		/* Im getting dizzy */


case "3":


global $mailboxlist;

$cleartext_password = OneTimePadDecrypt($key, $onetimepad);

/* print "Trying to connect to IMAP server...";
print "DEBUG: $username, $cleartext_password, ";
print $imapServerAddress;
print ", $imapPort, 0"; */

$imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0); 

$boxes = sqimap_mailbox_list($imapConnection);

/* print_r($boxes); */

if (count($boxes)) {
    // $mailboxlist = '<select name="'.$foldername.'">';
    for ($i = 0; $i < count($boxes); $i++) {
        $use_folder = true;

        /* if ((strtolower($boxes[$i]['unformatted']) != 'inbox') &&
            ($boxes[$i]['unformatted'] != $trash_folder)  &&
            ($boxes[$i]['unformatted'] != $sent_folder) &&
            ($boxes[$i]['unformatted'] != $draft_folder)) { */
            $box = $boxes[$i]['unformatted-dm'];

            $box2 = str_replace(' ', '&nbsp;', $boxes[$i]['unformatted-disp']);
            if (strtolower($imap_server_type) != 'courier' || strtolower($box) != 'inbox.trash') {
                $mailboxlist .= "<option value=\"$box\">$box2</option>\n";
            }
        /* } */
    }
    // $mailboxlist .= "</select>\n";
} else {
    $mailboxlist = "No folders found.";
}
sqimap_logout($imapConnection); 


$emailaddresses = getPref($data_dir, $username, 'email_address');

print_3_action($lang);

/* print $mailboxlist;  */

break;


case "4":
	if($sess['type']==4 && $sess['action']==1) {
		print "<p>You have chosen to keep every mail. This is the
		default action anyway, so you might want to start over
		with a rule that makes more sense.</p>";
		break;
	}
	
	$sieverule = makesinglerule($sess,"rule");
	$text = makesinglerule($sess,"text");

	print_4_confirmation($lang);

	break;

default:
	print '
	<p>Please use the buttons on the bottom instead of your
	browser\'s reload, back and forward buttons, to continue,
	cancel or start over making a rule.</p>
	';
	break;

}

printfooter($lang);
textdomain('squirrelmail');

?>
