<?php
/*
 * User-friendly interface to SIEVE server-side mail filtering.
 * Plugin for Squirrelmail 1.2+
 *
 * Copyright (c) 2002 Alexandros Vellis <avel@users.sourceforge.net>
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 */

/* Functions that spit out HTML, for addrule.php. */

include_once("config.php");

global $startitems;

function printheader($lang="en") {

global $PHP_SELF, $color, $part;

print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>New Rule Wizard</title>
<style type="text/css">
body {
        background: '.$color[4].';
	color: '.$color[8].';
        font-family: verdana, tahoma, arial, sans-serif;
        }
a:link {
        text-decoration: none;
        color: '.$color[7].';
        border: none 1px;
        margin: 1px;
        }
a:hover {
        background: '.$color[12].';
        text-decoration: none;
        color: '.$color[7].';
        }
a:visited {
        color: '.$color[13].';
        text-decoration: none;
        }
a:active {
        background: transparent;
        }
h1 {
        text-align: center;
        font-family: tahoma, verdana, lucida, helvetica, sans-serif;
        font-size: 2.0em;
	color: '.$color[0].';
        }
h2 {
        /* font-style: italic; */
        font-weight: bold;
        font-family: tahoma, lucida, helvetica, sans-serif;
        }


</style>
</head>
<body>

<form action="'.$PHP_SELF.'" method="POST">

<table cellpadding="2" cellspacing="2" border="1" align="center"
valign="middle" bgcolor="'.$color[3].'" width="80%" frame="hsides">
<tr bgcolor="'.$color[5].'">
<td>';

print _("New Rule Wizard - Step");
print ' '.$part.' ';
print _("of");
print ' 4';
print '
</td>
</tr>
<tr>
<td>';

}


/* ----------------------------------------------------------- */

function printfooter($lang="en") {

global $HTTP_SESSION_VARS, $part;

print '
</td>
</tr>

<tr bgcolor="'.$color[5].'">
<td align="center" valign="middle">

<input name="reset" value="';
print _("Clear this Form");
print '" " type="reset" />';

if ($part!=1) {
	print '<input name="startover" value="';
	print _("Start Over");
	print '" type="submit" />';
}

print '<input name="cancel" value="';
print _("Cancel");
print '" type="submit" /><br />';

if ($part!=1) {
	print '<input name="prev" value="&lt;&lt; ';
	print _("Move back to step");
	print ' '.($part-1).'" type="submit" />';
}

if ($part=="4") {
	print '<input name="finished" value="';
	print _("Finished");
	print '" type="submit" />';
} else {
	print '<input name="next" value="';
	print _("Move on to step");
	print ' '.($part+1).' &gt;&gt;" type="submit" />';
}
	
print '
</td>
</tr>
</table>
</form>
</body>
</html>';


}

/* ----------------------------------------------------------- */

function printnakedfooter() {

print '
</td>
</tr>
</table>

</form>
</body>
</html>';

}

/* ----------------------------------------------------------- */

function print_1_ruletype($lang="en") {

print '<h2>';
print _("Rule Type");

print '</h2><p>';

print _("What kind of rule would you like to add?");

print '</p>';


/*
<input type="radio" name="type" value="1" />Address Match<br />

<blockquote>
Match an address that appears on <strong>any</strong> header of a message.
</blockquote>
*/

print '<input type="radio" name="type" value="2" checked="" /> ';
print _("Header Match");
print '<br /><blockquote>';
print _("Perform an action on messages matching a specified header (From, To etc.).");
print '</blockquote>';

print '<input type="radio" name="type" value="3" /> ';
print _("Size");
print '<br /><blockquote>';
print _("Perform an action on messages depending on their size.");
print '</blockquote>';

print '<input type="radio" name="type" value="4" /> ';
print _("All Messages");
print '<br /><blockquote>';
print _("Perform an action on <strong>all</strong> incoming messages.");
print '</blockquote>';

print '</td></tr>';
}


/* ----------------------------------------------------------- */


function print_2_1_addressmatch($lang="en") {

print '<h2>';
print _("Address Match");
print '</h2>';

print _("The rule will trigger if the following addresses appear anywhere in the message's headers:");


for ( $i=0; $i<3; $i++) {


	print '<br />';

	if ($i != "0") {
		print '
		<select name="addressrel'.$i.'">
			<option value="0" name="none">(stop here)</option>
			<option value="and" name="and">and</option>
			<option value="or" name="or">or</option>
		</select>';
		}

	print '
</select>
	<input type="text" name="address'.$i.'" size="20" maxlength="50" value="someone@example.org" />
	';
	}

}


/* ----------------------------------------------------------- */
/* 2_2, Header match stuff functions. */

/* Print listbox widget with available headers to choose from. */
function print_header_listbox($selected_header, $n) {

global $headers;

print '<select name="header['.$n.']">';

foreach($headers as $header) {
	if ($header==$selected_header) {
		print '<option name="header['.$n.']"  value="'.$header.'" selected="">'.$header.':</option>';
	} else {
		print '<option name="header['.$n.']"  value="'.$header.'">'.$header.':</option>';
	}
}

print '</select>';
}


function print_matchtype_listbox($selected_matchtype, $n) {

$matchtypes = array(
"contains" => _("contains"),
"is" => _("is"),
"does not contain" => _("does not contain"),
"is not" => _("is not")
);

print '<select name="matchtype['.$n.']">';

while(list ($matchtype, $matchstring) = each ($matchtypes)) {
	if ($matchtype==$selected_matchtype) {
		print '<option value="'.$matchtype.'" selected="">'.$matchstring.'</option>';
	} else {
		print '<option value="'.$matchtype.'">'.$matchstring.'</option>';
	}
}
print '</select>';
}

function print_condition_listbox($selected_condition) {

$conditions = array(
"and" => _("AND (Every item must match)"),
"or" => _("OR (Either item will match)")
);

print _("The condition for the following rules is:");
print '<select name="condition">';

while(list ($condition, $conditionstring) = each ($conditions)) {
	if($condition==$selected_condition) {
		print '<option value="'.$condition.'" selected="">'.$conditionstring.'</option>';
	} else {
		print '<option value="'.$condition.'">'.$conditionstring.'</option>';
	}
}
print '</select>';

}

function print_2_2_headermatch($lang="en", $items = 3 /*$startitems */) {

global $HTTP_POST_VARS, $maxitems;

print "<h2>";
print _("Header Match");
print "</h2>";

print '<input type="hidden" name="items" value="'.$items.'" />';

if($items > 1) {
	print_condition_listbox($HTTP_POST_VARS['condition']);
}


print '<br /><ul>';

for ( $n=0; $n< $items; $n++) {

	print '<li>';
	print _("The header ");
	print_header_listbox($HTTP_POST_VARS['header'][$n], $n);
	print_matchtype_listbox($HTTP_POST_VARS['matchtype'][$n], $n);

	print '<input type="text" name="headermatch['.$n.']" size="24" maxlength="40" value="'.$HTTP_POST_VARS['headermatch'][$n].'" /></li><br />';

} /* End for loop */

print '<br />';

if($items > 1) {
	print '<input name="less" value="';
	print _("Less...");
	print '" type="submit" />';
}

if($items < $maxitems) {
	print '<input name="append" value="';
	print _("More...");
	print '" type="submit" />';
}

}
/* ----------------------------------------------------------- */

function print_2_3_sizematch($lang) {


print '<h2>';
print _("Size Match");

print '</h2><p>';
print _("This rule will trigger if message is");

print '<select name="sizerel"><option value="bigger" name="sizerel">';
print _("bigger");
print '</option><option value="smaller" name="sizerel">';
print _("smaller");
print '</option></select>';
print _("than");

print '<input type="text" name="sizeamount" size="10" maxlength="10" value="50" />
<select name="sizeunit">
<option value="kb" name="sizeunit">';
print _("KB (kilobytes)");
print '</option><option value="mb" name="sizeunit">';
print _("MB (megabytes)");
print '</option></select></p>';

}


/* ----------------------------------------------------------- */


function print_3_action($lang="en") {

/* Preferences from config.php */
global $useimages;

/* Data taken from addrule.php */
global $mailboxlist, $createnewfolder, $emailaddresses;

print '<tr><td><h2>';

print _("Action to Take");

print '</h2><p>';

print _("Choose what to do when this rule triggers, from one of the following:");

print '</p><input type="radio" name="action" value="1" checked="" />';
print _("Keep (Default action)");

print '<br /><input type="radio" name="action" value="2" />';
print _("Discard Silently");

print '<br /><input type="radio" name="action" value="3" />';
print _("Reject, sending this excuse to the sender:");
print '<br /><blockquote><textarea name="excuse" rows="4" cols="50">';
print _("Please do not send me large attachments.");
print '</textarea></blockquote><br />';

print '<input type="radio" name="action" value="4" />';
print _("Redirect to the following email address:");
print '<br /><blockquote><input type="text" name="redirectemail" size="26" maxlength="58" value="';
print _("someone@example.org");
print '" /></blockquote><br />';

print '<input type="radio" name="action" value="5" />';
print _("Move message into");
print '<br /><blockquote><input type="radio" name="newfolder" value="5a" checked="" />';
print _("the existing folder");
print '<select name="folder">'.$mailboxlist.'</select>';

if ($createnewfolder) {

print '<br /><input type="radio" name="newfolder" value="5b" />';
print _("a new folder, named");
print '<input type="text" size="25" name="folder_name">';
print _("created as a subfolder of");
print ' <select name="subfolder">'.$mailboxlist.'</select>';

}

print '</blockquote><input type="radio" name="action" value="6" /><strong>&quot;';
print _("Vacation");
print '&quot;</strong>:';
print _("The notice will be sent only once to each person that sends you mail, and will not be sent to a mailing list address.");
print '<br /><blockquote>';
print _("Addresses: Only reply if sent to these addresses:");
print '<input type="text" name="vac_addresses" value="'.$emailaddresses.'" size="60" maxsize="200"><br />';
print _("Days: Reply message will be resent after");
print ' <input type="text" name="vac_days" value="7" size="3" maxsize="4"> ';
print _("days");
print '<br />';
print _("Use the following message:");
print '<br /><textarea name="vac_message" rows="4" cols="50">';
print _("This is an automated reply; I am away and will not be able to reply to you immediately.");
print _("I will get back to you as soon as I return.");
print '</textarea></blockquote><br />';

print '<input type="checkbox" name="stop" /> ';

/* if using images at all, also use a nice little stop gif. :-) */

if ($useimages) {
	print '<img src="images/stop.gif" width="35" height="33" border="0" alt="';
	print _("STOP");
	print '" align="middle" /> ';
} else {
	print "<strong>"._("STOP").":</strong> ";
}

print _("If this rule matches, do not check any rules after it.");

print '</td></tr>';

} 

/* ----------------------------------------------------------- */

function print_4_confirmation($lang="en") {

/* global $sieverule; */
global $text;

print '<h2>';
print _("Confirmation");
print '</h2><p>';
print _("Your new rule states:");
print '</p><blockquote><p>'.$text.'</p></blockquote><p>';
print _("If this is what you wanted, select Finished. You can also start over or cancel adding a rule altogether.");
print '</p>';

}

?>
