<?php
/*
 * User-friendly interface to SIEVE server-side mail filtering.
 * Plugin for Squirrelmail 1.2+
 *
 * Copyright (c) 2002 Alexandros Vellis <avel@users.sourceforge.net>
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 */

/* Configuration parameters for SIEVE mail filters (aka avelsieve) */

/* Port where timsieved listens on the Cyrus IMAP server. Default is 2000. */

$port = 2000;

/* Conservative connections to IMAP/SIEVE server?
 * If true, avelsieve connects to timsieved only on connect and logout. In this
 * case, user  _must_ logout when she is done with changing her rules.  If false,
 * avelsieve connects to timsieved all the time and updates the rules.
 * ********** TRUE by default, since 0.4. *********** */

/* Working well, but there's probably still some work to do to make it perfect.
 * :-/ */

$conservative = true;

/* Use Images for the move up / down, delete rule buttons and STOP? */

$useimages = true;

/* Theme to use for the images. A directory with the same name must exist under
 * plugins/avelsieve/$imagetheme, that contains the files: up.png, down.png,
 * del.png. */

$imagetheme = 'plain';
//$imagetheme = 'opera_blue';
//$imagetheme = 'gnome-24';

/* Still experimental feature:
 * Enable Create New Folder routine in step #3 of adding a new rule?
 * Change to false if in a production environment. */

$createnewfolder = true;

/* NEW as of version 0.6: */

/* Number of items to display _initially_, when displaying the header match
 * rule */

$startitems = 3;

/* Maximum number of items to allow in the same place: */

$maxitems = 10;

/* Headers to display in listbox widget, when adding a new header rule. */

$headers = array(
"From", "To", "Cc", "Bcc", "Subject", "Reply-To", "Sender", "List-Id",
"MailingList", "X-ML-Name", "X-List", "List-Id", "X-Mailer");
// global $headers;

?>
