<?php
/*
 * User-friendly interface to SIEVE server-side mail filtering.
 * Plugin for Squirrelmail 1.2+
 *
 * Copyright (c) 1999-2002 The SquirrelMail Project Team
 * and Alexandros Vellis <avel@users.sourceforge.net>
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 * Also view plugins/README.plugins for more information.
 */
   
   function squirrelmail_plugin_init_avelsieve() {
      global $squirrelmail_plugin_hooks;
      global $mailbox, $imap_stream, $imapConnection;

      $squirrelmail_plugin_hooks['optpage_register_block']['avelsieve'] =
      'squirrelmail_plugin_avelsieve_optpage_register_block';
      $squirrelmail_plugin_hooks['menuline']['avelsieve'] =
      'squirrelmail_plugin_avelsieve_menuline';
      
   }

   function squirrelmail_plugin_avelsieve_optpage_register_block() {
      global $optpage_blocks;
      require_once('../functions/i18n.php');
      bindtextdomain ('avelsieve', '../locale');
      textdomain ('avelsieve');

      $optpage_blocks[] = array(
         'name' => _("Message Filters"),
         'url'  => '../plugins/avelsieve/table.php',
	 'desc' => _("Server-Side mail filtering enables you to add criteria in order to automatically forward, delete or place a given message into a folder."),
         'js'   => false
      );
      textdomain('squirrelmail');

   }
   
   function squirrelmail_plugin_avelsieve_menuline() {
   	$cwd = getcwd();
	if (!strstr($cwd, "avelsieve")) {
	        bindtextdomain ('avelsieve', '../locale');
	} else {
	        bindtextdomain ('avelsieve', '../../locale');
	}
        textdomain ('avelsieve');
   	displayInternalLink('plugins/avelsieve/table.php',_("Filters"),'right');
	echo "&nbsp;&nbsp\n";
        textdomain ('squirrelmail');
   }    
?>
