<?php
/*
 * User-friendly interface to SIEVE server-side mail filtering.
 * Plugin for Squirrelmail 1.2+
 *
 * Copyright (c) 2002 Alexandros Vellis <avel@users.sourceforge.net>
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 */

/* These are just my own wrapper functions around sieve-php.lib, with error
 * handling et al.
 */

require_once "sieve-php.lib";

function upload_script ($newscript) {
	global $sieve;

	//print "<pre>Sending the script...";
	//print $newscript;
	//print "</pre>";

	if($sieve->sieve_sendscript("phpscript", stripslashes($newscript))) {
		return true;
		/* print "Your rules have been successfully updated.<br />"; */
	} else {
		print "Unable to load script to server.  See server response below:<br />
		<blockquote><font color=#aa0000>";
		if(is_array($sieve->error_raw)) {
			foreach($sieve->error_raw as $error_raw)
                        print $error_raw."<br>";
		} else {
                	print $sieve->error_raw."<br>";
		}
		print "</font></blockquote>";
		return false;
	}
}

function delete_script () {
	global $sieve;

	if($sieve->sieve_deletescript("phpscript")) {
		return true;
	} else {
		print 'Unable to delete script from server. See server response below:<br />
		<blockquote><font color="red">';
		if(is_array($sieve->error_raw)) {
			foreach($sieve->error_raw as $error_raw)
				print $error_raw."<br>";
		} else {
			print $sieve->error_raw."<br>";
		}
	print "</font></blockquote>";
	return false;
	}
}

?>
